searchNodes=[{"doc":"Documentation for Blaze.","ref":"Blaze.html","title":"Blaze","type":"module"},{"doc":"A wrapper around GoogleApi.Firestore.V1.Api.Projects with simpler function names and automatic conversion between native Elixir types and Firestore models. Connections All connections are required to be Tesla connections, because that&#39;s what the official API library requires. However, you can create your own Tesla connection if you wish; the first parameter of every API function is a conn. If you don&#39;t want to create your own Tesla connection you may also use connection/1, passing in a Goth token, which will generate a valid Tesla connection for you. For example: token = Goth.Token.for_scope(scope) conn = Blaze.API.connection(token.token) This doesn&#39;t do much except wrap GoogleApi.Firestore.V1.Connection.new/1, but this way you can alias/import a single module (Blaze.API) rather than having to start including the official library modules. After all, this wrapper aims to completely remove the need to directly interact with the messy official API library.","ref":"Blaze.API.html","title":"Blaze.API","type":"module"},{"doc":"Create a new Firestore connection.","ref":"Blaze.API.html#connection/1","title":"Blaze.API.connection/1","type":"function"},{"doc":"Creates a new document. This will encode a native Elixir map to a document request prior to creation, as well as decoding the returned document model into a native Elixir map in the case of a successful response.","ref":"Blaze.API.html#create_document/5","title":"Blaze.API.create_document/5","type":"function"},{"doc":"Deletes a document at the given path. This is typically the fully-qualified collection path plus the document id. E.g. projects/project-id/databases/(default)/documents/some_collection/document_id. If you do not have the unique identifier for a given document, you may query for the document first by using list_documents/3 or run_query/3.","ref":"Blaze.API.html#delete_document/3","title":"Blaze.API.delete_document/3","type":"function"},{"doc":"Returns a document at the given path. This is typically the fully-qualified collection path plus the document id. E.g. projects/project-id/databases/(default)/documents/some_collection/document_id. If you do not have the unique identifier for a given document, you may query for the document first by using list_documents/3 or run_query/3.","ref":"Blaze.API.html#get_document/3","title":"Blaze.API.get_document/3","type":"function"},{"doc":"List all documents stored within a given collection. You may use :pageSize and :pageToken in the opts list to control how many results are returned per page as well as which page to start on.","ref":"Blaze.API.html#list_documents/4","title":"Blaze.API.list_documents/4","type":"function"},{"doc":"Parse a document response tuple so that any returned documents are native Elixir maps rather than Document models.","ref":"Blaze.API.html#parse_documents/1","title":"Blaze.API.parse_documents/1","type":"function"},{"doc":"Runs a structured query against the database. It is recommended to use Blaze.Query to build the structured query model to pass to this function.","ref":"Blaze.API.html#run_query/4","title":"Blaze.API.run_query/4","type":"function"},{"doc":"Updates a document at the given path. This is typically the fully-qualified collection path plus the document id. E.g. projects/project-id/databases/(default)/documents/some_collection/document_id. If a document does not exist at that path, a document is created.","ref":"Blaze.API.html#update_document/4","title":"Blaze.API.update_document/4","type":"function"},{"doc":"An interface to convert to and from GoogleApi.Firestore.V1.Model.Document. Create proper document structs by passing in primitive Elixir data types. You may simply call encode/1 passing in a Map and a valid Document model will be returned. Caveats There are some data types that don&#39;t natively map between the expected Value types and native Elixir types. When decoding these values, whatever raw data is returned in the response is returned as-is. When encoding these values, developers must wrap them in a tuple with a special key to denote what kind of type they should be mapped to. Those types are: :__firestore_bytes: Maps the bytesValue field. :__firestore_ref: Maps the referenceValue field. :__firestore_geo: Maps the geoPointValue field. :__firestore_time: Maps the timestampValue field. If you need to store raw bytes, a reference to another document, a geographic point, or a timestamp in a native format recognizable by Firestore then you must wrap those values in a tuple with the first element as one of the above corresponding keys. For example, to set a timestamp: iex&gt; encode_value({:__firestore_time, time_in_seconds}) %{timestampValue: %{seconds: time_in_seconds, nanos: 0}}","ref":"Blaze.Document.html","title":"Blaze.Document","type":"module"},{"doc":"Generate a map from a Document model.","ref":"Blaze.Document.html#decode/1","title":"Blaze.Document.decode/1","type":"function"},{"doc":"Decodes a Document Value into a native Elixir term. If a tuple is given, a tuple is returned with the second element being decoded.","ref":"Blaze.Document.html#decode_value/1","title":"Blaze.Document.decode_value/1","type":"function"},{"doc":"Generate a Document model from a map.","ref":"Blaze.Document.html#encode/1","title":"Blaze.Document.encode/1","type":"function"},{"doc":"Encodes a native Elixir term into a Document Value. If a tuple is given, the first element is assumed to represent a key. If the key matches a reserved key, it applies special encoding rules. If not, it returns a tuple with the second element being encoded. Read the module documentation (Caveats) for more information on the reserved keys and what rules are applied to each.","ref":"Blaze.Document.html#encode_value/1","title":"Blaze.Document.encode_value/1","type":"function"},{"doc":"Simplifies the process of constructing a Firestore query, similar to how Ecto.Query simplifies queries to its supported databases. The simplest way to get started is to import Blaze.Query: import Blaze.Query query = from(&quot;bookCollection&quot;, allDescendants: false) |&gt; limit(1) |&gt; where(author: &quot;Donald Knuth&quot;) Blaze.API.run_query(conn, parent_path, query)","ref":"Blaze.Query.html","title":"Blaze.Query","type":"module"},{"doc":"Create a single filter for one field. This could result in either a UnaryFilter or a FieldFilter being generated, although everything gets wrapped in a Filter model anyway for some reason.","ref":"Blaze.Query.html#create_filter/1","title":"Blaze.Query.create_filter/1","type":"function"},{"doc":"Creates one or more filters from a keyword list or map of conditions. Conditions may either be field comparisons filters or unary field filters. See the module documentation sections for Comparison Operators and Unary Filters for more information.","ref":"Blaze.Query.html#create_filters/1","title":"Blaze.Query.create_filters/1","type":"function"},{"doc":"","ref":"Blaze.Query.html#create_order/1","title":"Blaze.Query.create_order/1","type":"function"},{"doc":"","ref":"Blaze.Query.html#create_ordering/1","title":"Blaze.Query.create_ordering/1","type":"function"},{"doc":"Convert a direction atom to its string representation.","ref":"Blaze.Query.html#direction/1","title":"Blaze.Query.direction/1","type":"function"},{"doc":"Creates a Filter model with the fieldFilter attribute set.","ref":"Blaze.Query.html#field_filter/3","title":"Blaze.Query.field_filter/3","type":"function"},{"doc":"Convert a field operator atom to its string representation. Uses the value as context to determine both validity and, in the case of :contains, which specific string representation is needed.","ref":"Blaze.Query.html#field_op/2","title":"Blaze.Query.field_op/2","type":"function"},{"doc":"Constructs a new query object that executes against the given collection.","ref":"Blaze.Query.html#from/1","title":"Blaze.Query.from/1","type":"function"},{"doc":"Updates an existing query to execute against the given collection. If a query isn&#39;t given, a new query object is created for the given collection and options list.","ref":"Blaze.Query.html#from/2","title":"Blaze.Query.from/2","type":"function"},{"doc":"Updates ane existing query to execute against the given collection with the given set of options. Options can be: allDescendants - boolean - When false, only selects collections that are immediate descendants of the parent path specified in the API call.","ref":"Blaze.Query.html#from/3","title":"Blaze.Query.from/3","type":"function"},{"doc":"","ref":"Blaze.Query.html#limit/2","title":"Blaze.Query.limit/2","type":"function"},{"doc":"","ref":"Blaze.Query.html#offset/2","title":"Blaze.Query.offset/2","type":"function"},{"doc":"Adds one or more order by clauses to the query. If a list is provided, the elements may be either field references or a tuple with a field reference and an atom representing directionality: :asc or :desc. If a map is provided, every key must be a field reference and every value must be a direction atom.","ref":"Blaze.Query.html#order/2","title":"Blaze.Query.order/2","type":"function"},{"doc":"Creates a filter for the query. If a where clause has already been added to the query, the filter is either &quot;upgraded&quot; to a composite filter from a field or unary filter, or the new conditions are simply added to the existing composite filter. Unary Filters It&#39;s possible to perform one of two unary filters on a field: Checking for &quot;NaN&quot; Checking for &quot;Null&quot; To perform either of these built-in unary filters, you can do the following: # Check for &quot;NaN&quot; where(query, grade: :nan) # Check for &quot;Null&quot; where(query, grade: nil) Any time a key for a given field is either :nan or nil, a unary filter is created. If additional fields and values are given, any unary filters will be added to a composite filter along with the remainder of the fields. Comparison Operators By default, if the value for a field is a list then the filter uses the in operator (e.g. day_of_week in [1, 2, 3]). For all other values the filter uses = as the operator (e.g. day_of_week = 5). You can customize the operator by passing a tuple for the value in the form of {op, val}. For example: # Filter for `grade &gt;= 80` where(query, grade: {:gte, 80}) # Filter for `regions contains &quot;us-west&quot;` where(query, regions: {:contains, &quot;us-west&quot;}) The full list of possible operators: :eq - Field equals a value :lt - Field less than a value :lte - Field less than or equal a value :gt - Field is greater than a value :gte - Field is greater than or equal to a value :contains - Field contains at least one of a set of values :in - Field matches at least one of a set of values For the :contains operator, this only works when the field being filtered is an array type. When the value is a list, the :contains operator is equivalent to &quot;the field has at least one element that matches an element in the given value list.&quot; When the value is anything else, the :contains operator is equivalent to &quot;the field has at least one element that matches the given value.&quot; For the :in operator, this only works when the field being filtered is not an array or map type. The value list passed in must be an array of values that match the type of the field. E.g. if the field being filtered is an integer then the list of possible values must be a list of integers. Caveats Warning: Firestore only supports and operators for composite filters, so calling where multiple times will create multiple and conditions. For example: query |&gt; where(author: &quot;Donald Knuth&quot;) |&gt; where(author: &quot;William Gibson&quot;) The above won&#39;t work because Firestore can only interpret that as &quot;author is Donald Knuth AND William Gibson&quot;. Calling the where function multiple times is better suited for composing incremental, compounding filters rather than expanding existing filters.","ref":"Blaze.Query.html#where/2","title":"Blaze.Query.where/2","type":"function"},{"doc":"","ref":"Blaze.Query.html#t:t/0","title":"Blaze.Query.t/0","type":"type"}]